// TheWell.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "WaterSurfaceJacobiGPU.h"
#include "WaterSurfaceCGGPU.h"
#include "WaterSurfaceFullGPU.h"
#include "Walls.h"
#include "EnvironmentMap.h"
#include "Engine.h"


	//char *debug_envmap[] = {"media/debug_posx.png", "media/debug_negx.png", "media/debug_posy.png",
	//	"media/debug_negy.png", "media/debug_posz.png", "media/debug_negz.png"};
	//char *gradient_envmap[] = {"media/gradient_posx.png", "media/gradient_negx.png", "media/gradient_posy.png",
	//	"media/gradient_negy.png", "media/gradient_posz.png", "media/gradient_negz.png"};
	//char *quadrangle_envmap[] = {"media/quadrangle_posx.png", "media/quadrangle_negx.png", "media/quadrangle_posy.png",
	//	"media/quadrangle_negy.png", "media/quadrangle_posz.png", "media/quadrangle_negz.png"};
	//char *brightday2_envmap[] = {"media/brightday2_posx.png", "media/brightday2_negx.png", "media/brightday2_posy.png",
	//	"media/brightday2_negy.png", "media/brightday2_posz.png", "media/brightday2_negz.png"};
	//char *sunset_envmap[] = {"media/sunset_posx.jpg", "media/sunset_negx.jpg", "media/sunset_posy.jpg",
	//	"media/sunset_negy.jpg", "media/sunset_posz.jpg", "media/sunset_negz.jpg"};
	//char *nvlobby_envmap[] = {"media/nvlobby_posx.png", "media/nvlobby_negx.png", "media/nvlobby_posy.png",
	//	"media/nvlobby_negy.png", "media/nvlobby_posz.png", "media/nvlobby_negz.png"};
	//char *planetscape_envmap[] = {"media/800_posx.jpg", "media/800_negx.jpg", "media/800_posy.jpg",
	//	"media/800_negy.jpg", "media/800_posz.jpg", "media/800_negz.jpg"};

int _tmain(int argc, _TCHAR* argv[])
{
	// basic initialization of GLUT
	glutInit(&argc, (char**)argv);

	int size = 128;

	Engine::Instance()->Initialize(1024, 768, size);

	EnvironmentMap *envmap = new EnvironmentMap("sunset", "jpg", 512);
	WaterSurface *ws = new WaterSurfaceCGGPU(size, 1.0f, 10.0f);
	Walls *walls = new Walls(size, 1.0f, 10.0f);

	for (int i = 60; i < 90; i++) {
		for (int j = 30; j < 60; j++) {
//	for (int i = 3; i < 5; i++) {
//		for (int j = 2; j < 5; j++) {
			ws->setHeight(i, j, 18.0f);
		}
	}

	for (int i = 50; i < 80; i++) {
		for (int j = 90; j < 120; j++) {
			ws->setHeight(i, j, 7.0f);
		}
	}

	// start and run engine
	Engine::Instance()->Add(envmap);
	Engine::Instance()->Add(walls);
	Engine::Instance()->Add(ws);
	Engine::Instance()->Run();
}