#include "StdAfx.h"
#include "TimeTaker.h"

TimeTaker::TimeTaker(const char *name)
: running_(false), total_time_(0), start_time_(0), name_(name)
{
}

void TimeTaker::Reset()
{
	running_ = false;
	total_time_ = 0;
	start_time_ = 0;
}

unsigned long TimeTaker::TotalTime()
{
	return total_time_;
}

void TimeTaker::PrintTime()
{
	std::cout << name_.c_str() << ": ";
	unsigned long time = total_time_;
	int h = (int) time / (1000*60*60);
	time -= h*1000*60*60;
	int m = (int) time / (1000*60);
	time -= m*1000*60;
	int s = (int) time / 1000;
	time -= s*1000;
	int ms = (int) time;

	if (h > 0)
	{
		std::cout << h << "h ";
	}
	if (m > 0 || h > 0)
	{
		std::cout << m << "m ";
	}
	if (s > 0 || m > 0 || h > 0)
	{
		std::cout << s << "s ";
	}
	std::cout << ms << "ms" << std::endl;
}