#pragma once

class TimeTaker
{
public:
	TimeTaker(const char *name);
	void Start();
	void Stop();
	void Reset();

	unsigned long TotalTime();
	void PrintTime();

private:
	std::string name_;
	bool running_;
	unsigned long total_time_;
	unsigned long start_time_;
};

inline
void TimeTaker::Start()
{
	unsigned long now = GetTickCount();
	if (running_)
	{
		total_time_ += now - start_time_;
	}
	start_time_ = now;
	running_ = true;
}

inline
void TimeTaker::Stop()
{
	if (running_)
	{
		total_time_ += GetTickCount() - start_time_;
		running_ = false;
	}
	start_time_ = 0;
}
