#include "Stdafx.h"
#include "Walls.h"

Walls::Walls(unsigned int waterSize, float spacing, float waterLevel)
: size(waterSize * spacing), height(waterLevel)
{
	float ambient[] = { 0.0f, 0.0f, 0.0f, 0.0f };
	float diffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float specular[] = { 0.2f, 0.2f, 0.2f, 1.0f };
	float shininess = 0.0f;

	glGenTextures(1, &wallTex);
	glBindTexture(GL_TEXTURE_2D, wallTex);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	wallTex = ilutGLLoadImage((ILstring)("media/brick.jpg"));
	GLuint err = ilGetError();
	if(err != IL_NO_ERROR) exit(-1);

	glBindTexture(GL_TEXTURE_2D, 0);

	/*listHandle = glGenLists(1);
	glNewList(listHandle, GL_COMPILE);
		glColor3f(1.0f, 0.0f, 0.0f);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse);
		glMaterialfv(GL_FRONT, GL_AMBIENT, ambient);
		glMaterialfv(GL_FRONT, GL_SPECULAR, specular);
		glMaterialf(GL_FRONT, GL_SHININESS, shininess);
		glBegin(GL_QUADS);
			glVertex3f(0.0f, height, 0.0f);
			glVertex3f(size, height, 0.0f);
			glVertex3f(size, 0.0f, 0.0f);
			glVertex3f(0.0f, 0.0f, 0.0f);
			
			glVertex3f(0.0f, 0.0f, size);
			glVertex3f(size, 0.0f, size);
			glVertex3f(size, height, size);
			glVertex3f(0.0f, height, size);
		glEnd();
	glEndList();*/
}

Walls::~Walls() {}

void Walls::update(int ticks)
{
}

void Walls::display()
{
	float size1 = size - 1.0f;
	float height8 = height + 8.0f;
	
	glPushMatrix();

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D, wallTex);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f,		-100.0f,	0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1,		-100.0f,	0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1,		height8,	0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f,		height8,	0.0f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f,      -100.0f,	size1);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f,      height8,	size1);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1,		height8,	size1);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1,		-100.0f,	size1);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(size1,		-100.0f,	size1);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(size1,		height8,	size1);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1,		height8,	0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1,		-100.0f,	0.0f);

		glTexCoord2f(1.0f, 0.0f); glVertex3f(0.0f,      -100.0f,	0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(0.0f,		height8,	0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f,      height8,	size1);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f,      -100.0f,	size1);

		// inside bottom
		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f,      -100.0f,	0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(0.0f,      -100.0f,	size1);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1,		-100.0f,	size1);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(size1,		-100.0f,	0.0f);

		// outside bottom
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f,     -100.0f,	-3.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1+3.0f,-100.0f,	-3.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1+3.0f,-100.0f,	size1+3.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,     -100.0f,	size1+3.0f);

		glTexCoord2f(1.0f, 0.0f); glVertex3f(-3.0f,     -100.0f,	-3.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-3.0f,		height8,	-3.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(size1+3.0f,height8,	-3.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(size1+3.0f,-100.0f,	-3.0f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f,     -100.0f,	size1+3.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1+3.0f,-100.0f,	size1+3.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1+3.0f,height8,	size1+3.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,     height8,	size1+3.0f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(size1+3.0f,-100.0f,	size1+3.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(size1+3.0f,-100.0f,	-3.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(size1+3.0f,height8,	-3.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(size1+3.0f,height8,	size1+3.0f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f,     -100.0f,	-3.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-3.0f,     -100.0f,	 size1+3.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-3.0f,     height8,	size1+3.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-3.0f,		height8,	-3.0f);

		glTexCoord2f(2.0f, 0.1f); glVertex3f(0.0f,		height8,	0.0f);
		glTexCoord2f(0.1f, 0.1f); glVertex3f(size1,		height8,	0.0f);
		glTexCoord2f(0.1f, 0.0f); glVertex3f(size1+3.0f,height8,	-3.0f);
		glTexCoord2f(2.0f, 0.0f); glVertex3f(-3.0f,		height8,	-3.0f);

		glTexCoord2f(0.1f, 0.0f); glVertex3f(0.0f,      height8,	size1);
		glTexCoord2f(0.1f, 0.1f); glVertex3f(-3.0f,     height8,	size1+3.0f);
		glTexCoord2f(2.0f, 0.1f); glVertex3f(size1+3.0f,height8,	size1+3.0f);
		glTexCoord2f(2.0f, 0.0f); glVertex3f(size1,		height8,	size1);

		glTexCoord2f(0.1f, 2.0f); glVertex3f(size1,		height8,	size1);
		glTexCoord2f(0.0f, 2.0f); glVertex3f(size1+3.0f,height8,	size1+3.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(size1+3.0f,height8,	-3.0f);
		glTexCoord2f(0.1f, 0.0f); glVertex3f(size1,		height8,	0.0f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f,		height8,	0.0f);
		glTexCoord2f(0.1f, 0.0f); glVertex3f(-3.0f,		height8,	-3.0f);
		glTexCoord2f(0.1f, 2.0f); glVertex3f(-3.0f,     height8,	size1+3.0f);
		glTexCoord2f(0.0f, 2.0f); glVertex3f(0.0f,      height8,	size1);
	glEnd();
	glBindTexture(GL_TEXTURE_2D, 0);
	glDisable(GL_TEXTURE_2D);

	glPopMatrix();
}
