#pragma once

#include "WaterSurfaceGPU.h"
//#include "Shader.h"

class WaterSurfaceCGGPU : public WaterSurfaceGPU
{
public:
	WaterSurfaceCGGPU(unsigned int surfaceSize, float spacing, float waterLevel);
	~WaterSurfaceCGGPU();

protected:
	virtual void solver();
	void CG(int imax, float tolerance);
	
	void matrixA5VectorMult(unsigned int texX, unsigned int texResult);
	void subtract(unsigned int texX, unsigned int texY, unsigned int texResult);
	float dotProduct(unsigned int texX, unsigned int texY);
	void scalarMult(float scalar, unsigned int texX, unsigned int texResult);
	void add(unsigned int texX, unsigned int texY, unsigned int texResult);
	float length(unsigned int texX);


	GPShaderProgram a5vectormultShader;
	GPShaderProgram subtractShader;
	GPShaderProgram innermultShader;
	GPShaderProgram sumreductionShader;
	GPShaderProgram scalarmultShader;
	GPShaderProgram addShader;

	FBO fbo;
	unsigned int texA;
	unsigned int texH;
	unsigned int texB;
	unsigned int texR0;
	unsigned int texR1;
	unsigned int texR01;
	unsigned int texRi;
	unsigned int texPi;
	unsigned int texAPi;
};