#pragma once

#include "WaterSurfaceGPU.h"
#include "Shader.h"
#include "FBO.h"

class WaterSurfaceFullGPU : public WaterSurfaceGPU
{
public:
	WaterSurfaceFullGPU(unsigned int surfaceSize, float spacing, float waterLevel);
	~WaterSurfaceFullGPU();
	virtual void update(int ticks);

protected:
	virtual void computeDeparture();
	virtual void prepareSolver();
	virtual void solver();
	//virtual void postSolver();

	void jacobi(int imax);
	void jacobiCPU(int imax, float tolerance);
	float sqrdist(float *x, float *y);

	bool updateTextures;

	GPShaderProgram departureShader;
	GPShaderProgram prepareJacobiShader;
	GPShaderProgram jacobiShader;
	GPShaderProgram postJacobiShader;

	FBO fbo; // using the same FBO for all shaders
	unsigned int texUV;
	unsigned int texH;
	unsigned int texAltH;
	unsigned int texTildeHUV;
	unsigned int texAB;
};