#pragma once

#include "WaterSurface.h"
#include "Shader.h"
#include "FBO.h"

/// Contains helper functions for GPU handling
class WaterSurfaceGPU : public WaterSurface
{
public:
	WaterSurfaceGPU(unsigned int surfaceSize, float spacing, float waterLevel);
	~WaterSurfaceGPU();
	virtual void printStatistics();

protected:
	//virtual void computeDeparture();

	void setupView(unsigned int width, unsigned int height);
	unsigned int createTexture(const float *data);
	unsigned int createPackedTexture(const float *data);
	void writeTexture(unsigned int texture, const float *r, const float *g, const float *b, const float *a);
	void writePackedTexture(unsigned int texture, const float *data);

	void readTexture(unsigned int texture, float *data, int offset);
	void copyTexture(FBO &fbo, unsigned int texOriginal, unsigned int texCopy);

	GPShaderProgram deppointShader;
	FBO deppointFBO;
	unsigned int deppointValuesTex;
	unsigned int deppointResultTex;

	float *rgbaData;

	TimeTaker ttArray;
	TimeTaker ttTexImage;
	TimeTaker ttOverhead;
	TimeTaker ttShader;

private:
	unsigned int createTexture(unsigned int width, unsigned int height, const float *data);
};