#pragma once

#include "WaterSurfaceGPU.h"

class WaterSurfaceJacobiGPU : public WaterSurfaceGPU
{
public:
	WaterSurfaceJacobiGPU(unsigned int surfaceSize, float spacing, float waterLevel);
	~WaterSurfaceJacobiGPU();

protected:
	virtual void solver();
	void jacobi(int imax, float tolerance);
	float sqrdist(float *x, float *y);

	GPShaderProgram jacobiShader;
	FBO jacobiFBO;
	unsigned int jacobiTex1;
	unsigned int jacobiTex2;
};

class WaterSurfaceJacobiPackedGPU : public WaterSurfaceGPU
{
public:
	WaterSurfaceJacobiPackedGPU(unsigned int surfaceSize, float spacing, float waterLevel);
	~WaterSurfaceJacobiPackedGPU();

protected:
	virtual void solver();
	void jacobi(int imax, float tolerance);

	GPShaderProgram jacobiShader;
	FBO jacobiFBO;
	unsigned int texA;
	unsigned int texh1;
	unsigned int texh2;
	unsigned int texb;
};
