uniform sampler2D A;
uniform sampler2D X;
uniform float Width;

vec2 getCoord(in float offset)
{
	vec2 result;
	float ds = gl_TexCoord[0].s + offset/Width;
	return vec2(fract(ds), gl_TexCoord[0].t + floor(ds)/Width);
}

void main(void)
{
	// convert from 1D coord to 2D
	vec2 coord1 = getCoord(1.0);
	vec2 coord2 = getCoord(Width);
	vec2 coord3 = getCoord(-Width);
	vec2 coord4 = getCoord(-1.0);
	
	vec4 avec = vec4(-1, -1, -1, -1);
	vec4 xvec = vec4(
		texture2D(X, coord1).x, 
		texture2D(X, coord2).x, 
		texture2D(X, coord3).x, 
		texture2D(X, coord4).x
	);
	vec4 res = avec * xvec;
	
	//gl_FragColor.x = coord1.x;
	gl_FragColor.x = texture2D(A, gl_TexCoord[0].st).x*texture2D(X, gl_TexCoord[0].st).x
		+ res.x + res.y + res.z + res.w;
}