uniform sampler2D texH;
uniform sampler2D texUV;
uniform int size;
uniform float dT;
uniform float dS;

void main(void)
{
	// x = h, y = u, z = v
	float h = texture2D(texH, gl_TexCoord[0].st).x;
	vec2 uv = texture2D(texUV, gl_TexCoord[0].st).xy;
	vec4 dep;
	
	// departure point from (31)
	float aX = dT * uv.x;
	float aZ = dT * uv.y;
	float depX = ((gl_TexCoord[0].s * size * dS)-(dS/2.0)-aX) / dS;
	float depZ = ((gl_TexCoord[0].t * size * dS)-(dS/2.0)-aZ) / dS;

	int m_1, m, n_1, n; // table positions
	m = int(depX*dS + 1);
	m_1 = m - 1;
	n = int(depZ*dS + 1);
	n_1 = n - 1;

	if (m_1 < 0)
	{
		m_1 = 0;
		m = 1;
	}
	else if (m >= size)
	{
		m_1 = size - 2;
		m = size - 1;
	}

	if (n_1 < 0)
	{
		n_1 = 0;
		n = 1;
	}
	else if (n >= size)
	{
		n_1 = size - 2;
		n = size - 1;
	}
	
	vec4 pos = vec4(float(m), float(m_1), float(n), float(n_1)) / float(size);
	vec2 posMN = pos.xz;
	vec2 posM1N = pos.yz;
	vec2 posMN1 = pos.xw;
	vec2 posM1N1 = pos.yw;

//	vec2 posMN = vec2(float(m)/float(size), float(n)/float(size));
//	vec2 posM1N = vec2(float(m_1)/float(size), float(n)/float(size));
//	vec2 posMN1 = vec2(float(m)/float(size), float(n_1)/float(size));
//	vec2 posM1N1 = vec2(float(m_1)/float(size), float(n_1)/float(size));

	float x = float(m)*dS - depX;
	float z = float(n)*dS - depZ;
	
	vec3 mn = vec3(texture2D(texH, posMN).x, texture2D(texUV, posMN).xy);
	vec3 mn1 = vec3(texture2D(texH, posMN1).x, texture2D(texUV, posMN1).xy);
	vec3 m1n = vec3(texture2D(texH, posM1N).x, texture2D(texUV, posM1N).xy);
	vec3 m1n1 = vec3(texture2D(texH, posM1N1).x, texture2D(texUV, posM1N1).xy);
	
	dep.xyz = mix(mix(mn, mn1, z), mix(m1n, m1n1, z), x);
	
	gl_FragColor = dep;
}