uniform sampler2D texH;
uniform sampler2D texTildeHUV;
uniform int size;
uniform float dT;
uniform float dS;
uniform float g;

void main(void)
{
	float h = texture2D(texH, gl_TexCoord[0].st).x;
	
	float constant = (dS*dS) / (dT*dT*g);
	vec4 AB; // x = A, y = B
	
	vec2 pos = gl_TexCoord[0].st;
	vec2 posLeft = vec2(pos.x - 1.0/size, pos.y);
	vec2 posRight = vec2(pos.x + 1.0/size, pos.y);
	vec2 posTop = vec2(pos.x, pos.y - 1.0/size);
	vec2 posBottom = vec2(pos.x, pos.y + 1.0/size);
	
	AB.x = 4.0 + constant / h;
	AB.y = (texture2D(texTildeHUV, pos).x * constant / h)
		- ((dS / (2*dT*g)) 
		   * (texture2D(texTildeHUV, posBottom).y - texture2D(texTildeHUV, posTop).y 
		      + texture2D(texTildeHUV, posRight).z - texture2D(texTildeHUV, posLeft).z));

/*b[pos] = (tildeH[pos] * constant / h[pos])
- ((dS / (2*dT*g)) * 
(tildeU[pos+(i<size-1?size:0)] - tildeU[pos-(i>0?size:0)] + tildeV[pos+(j<size-1?1:0)] - tildeV[pos-(j>0?1:0)]));
*/		      
	gl_FragColor = AB;
}