uniform sampler2D tex;
uniform int size;
uniform float delta_size;
//uniform float delta_t;
	
void main()
{
	float delta_t = 0.005;
	float delta_size_1 = 1.0 / delta_size;
	float dss = float(size) * delta_size;

	vec2 texCoord = gl_TexCoord[0].st;
	vec4 c  = texture2D(tex, texCoord);
	vec4 dep = vec4(0.0, 0.0, 0.0, 0.0);

	float alpha_x = delta_t * c.y;
	float alpha_z = delta_t * c.z;
	
	float dep_p_x = float(texCoord.t * dss - (delta_size / 2.0) - alpha_x) * delta_size_1;
	float dep_p_z = float(texCoord.s * dss - (delta_size / 2.0) - alpha_z) * delta_size_1;
	
	int xm_1 = int(dep_p_x);
	int xm   = xm_1 + 1;
	int zn_1 = int(dep_p_z);
	int zn   = zn_1 + 1;
	
	if (xm_1 < 0) {
		xm_1 = 0;
		xm = 0;
	} else if (xm < 0) {
		xm_1 = 0;
	} else if (xm >= size) {
		xm = size-1;
		xm_1 = size-1;
	} else if (xm_1 >= size) {
		xm_1 = size-1;
	}
	if (zn_1 < 0) {
		zn_1 = 0;
		zn = 0;
	} else if (zn < 0) {
		zn = 0;
	} else if (zn >= size) {
		zn = size-1;
		zn_1 = size-1;
	} else if (zn_1 >= size) {
		zn_1 = size-1;
	}
	
	// bruke mix istedenfor z1 og z2
	
	if (xm == xm_1) {
		if (zn == zn_1) {
			dep.x = texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).x;
			dep.y = texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).y;
			dep.z = texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).z;
		} else {
			float z1 = (float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1;
			float z2 = 1.0-z1; //(texCoord.s*dss - (delta_size / 2.0) - alpha_z - float(zn_1)/2.0) * delta_size_1;
			dep.x = z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).x + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).x;
			dep.y = z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).y + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).y;
			dep.z = z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).z + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).z;
		}
	} else {
		float x1 = (float(xm)/2.0 - texCoord.t*dss + (delta_size / 2.0) + alpha_x) * delta_size_1;
		float x2 = 1.0-x1; //(texCoord.t*dss - (delta_size / 2.0) - alpha_x - float(xm_1)/2.0) * delta_size_1;
		if (zn == zn_1) {
			dep.x = x1*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).x + x2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).x;
			dep.y = x1*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).y + x2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).y;
			dep.z = x1*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).z + x2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).z;
		} else {
			float z1 = (float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1;
			float z2 = 1.0-z1; //(texCoord.s*dss - (delta_size / 2.0) - alpha_z - float(zn_1)/2.0) * delta_size_1;
			dep.x = x2*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).x + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).x) + x1*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm_1)/float(size))).x + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).x);
			dep.y = x2*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).y + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).y) + x1*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm_1)/float(size))).y + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).y);
			dep.z = x2*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).z + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).z) + x1*(z1*texture2D(tex, vec2(float(zn_1)/float(size), float(xm_1)/float(size))).z + z2*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).z);
		}
	}
	
	/*dep.x = (1.0-((float(xm)/2.0 - texCoord.t*dss + (delta_size / 2.0) + alpha_x) * delta_size_1))*(((float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1)*texture2D(tex, vec2(float(zn_1)/float(size), float(xm)/float(size))).x + (1.0-((float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1))*texture2D(tex, vec2(float(zn)/float(size), float(xm)/float(size))).x) + ((float(xm)/2.0 - texCoord.t*dss + (delta_size / 2.0) + alpha_x) * delta_size_1)*(((float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1)*texture2D(tex, vec2(float(zn_1)/float(size), float(xm_1)/float(size))).x + (1.0-((float(zn)/2.0 - texCoord.s*dss  + (delta_size / 2.0) + alpha_z) * delta_size_1))*texture2D(tex, vec2(float(zn)/float(size), float(xm_1)/float(size))).x);
	dep.y = 1.0 - dep.x;
	dep.z = float(zn_1);
	dep.w = float(zn);*/
	
	gl_FragColor = dep;
	//gl_FragColor = vec4(0.2, 0.3, 0.4, 0.5);
}
